/*
Copyright (C) 1998, 1999, 2000 Wabasoft

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA. 
*/

/*
Copyright (C) 2000, 2001 SMARTDATA, http://www.smartdata.ch/

More help for porting is include in the file nmport_a.c. Please read it before
porting or modify this port.

Linux port.
===========

*/

/* all the needed include */
#include "../waba.h"

#ifndef LINUX
# error You must define the LINUX symbol as gcc parameter (-DLINUX=1)
#endif

#ifndef FASTANDBIG

uint32 getUInt32(uchar *b)
{
  return (uint32)( (uint32)((b)[0])<<24 |
		   (uint32)((b)[1])<<16 |
		   (uint32)((b)[2])<<8  |
		   (uint32)((b)[3]) );
}

uint16 getUInt16(uchar *b)
{
  return (uint16)(((b)[0]<<8)|(b)[1]);
}

int32 getInt32(uchar *b)
{
  return (int32)( (uint32)((b)[0])<<24 |
		  (uint32)((b)[1])<<16 |
		  (uint32)((b)[2])<<8  |
		  (uint32)((b)[3]) );
}

int16 getInt16(uchar *b)
{
  return (int16)(((b)[0]<<8)|(b)[1]);
}

#endif  /* ifndef FASTANDBIG */

float32 getFloat32(uchar *buf) {
    uint32 i;
    float32 f;

    // we need to make sure we're aligned before casting
    i =
	((uint32)buf[0] << 24) |
	((uint32)buf[1] << 16) |
	((uint32)buf[2] << 8 ) |
	(uint32)buf[3];
    f = *((float32 *)&i);

    return f;

}

/*
   Local Variables:
   c-file-style: "smartdata"
   End:
*/
