/*
Copyright (C) 1998, 1999, 2000 Wabasoft

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA. 
*/

/* all the needed include */
#include "../waba.h"

#ifndef FASTANDBIG

uint32 getUInt32(uchar *b)
	{
	return (uint32)( (uint32)((b)[0])<<24 | (uint32)((b)[1])<<16 | (uint32)((b)[2])<<8 | (uint32)((b)[3]) );
	}
uint16 getUInt16(uchar *b)
	{
	return (uint16)(((b)[0]<<8)|(b)[1]);
	}
int32 getInt32(uchar *b)
	{
	return (int32)( (uint32)((b)[0])<<24 | (uint32)((b)[1])<<16 | (uint32)((b)[2])<<8 | (uint32)((b)[3]) );
	}
int16 getInt16(uchar *b)
	{
	return (int16)(((b)[0]<<8)|(b)[1]);
	}

#endif

float32 getFloat32(uchar *buf)
{
	uint32  i;
	float32 f;

	// we need to make sure we're aligned before casting
	i = ((uint32)buf[0] << 24) | ((uint32)buf[1] << 16) | ((uint32)buf[2] << 8) | (uint32)buf[3];
	f = *((float32 *)&i);
	
	return f;
}

//
// x portability functions
//

void* xmalloc(uint32 size)
{
	VoidHand    memH;
	uchar*      ptr;

	// we stick the handle in the first bytes and then return a pointer
	// inside the memory block. Then when we free it, we can get the
	// memory handle back to unlock and free it without having to track it.
	memH = MemHandleNew(sizeof(VoidHand) + size);
	
	if(!memH)
		return NULL;
		
	ptr = MemHandleLock(memH);
	
	*((VoidHand*)ptr) = memH;
	
	ptr += sizeof(VoidHand);
	
	return ptr;
}

void xfree(void *p)
{
	VoidHand    memH;
	uchar*      ptr;

	ptr = (uchar *)p - sizeof(VoidHand);
	
	memH = *((VoidHand *)ptr);
	
	MemHandleUnlock(memH);
	
	MemHandleFree(memH);
}
