#ifndef __NMWIN32_B_H__
#define __NMWIN32_B_H__

/*
Copyright (C) 1998, 1999, 2000 Wabasoft

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.
*/

//#define NEVER 1
//#define DUMPERRORTRACE 1
//#define DEBUGCMDLINE 1
//#define PRINTOPTIONS 1

static int g_mainWinWidth = 0;
static int g_mainWinHeight = 0;
static DWORD g_startTime = 0;
static DWORD g_messageTime = 0;
static HINSTANCE g_hInstance;
static TCHAR *pszWndClassName = TEXT("WabaWndClass");

#define WARP_CORE_PATH "\\Program Files\\waba\\waba.wrp"

#define MAX_CLASSPATHS 20
static int numClassPaths = -1;
static char *classPaths[MAX_CLASSPATHS];

typedef struct
    {
    HANDLE fileH;
    HANDLE mapH;
    int viewIsMapped;
    uchar *ptr;
    } MemFile;

#define MAX_MEM_FILES 16
static MemFile memFiles[MAX_MEM_FILES];
static uint32 numMemFiles = 0;
static int memFileNotSupported = 0;
static int win32WSAStarted = 0;

static HFONT createWin32Font(WObject font);

#ifdef QUICKBIND
static int32 postPaintMethodMapNum = -1;
static int32 postEventMethodMapNum = -1;
static int32 onTimerTickMethodMapNum = -1;
#endif

int asciiToUnicode(char *src, TCHAR *dst, int max);
uchar *loadFromMem(char *path, uint32 pathLen, uint32 *size);
uchar *readFileIntoMemory(char *path, int nullTerminate, uint32 *size);
int32 getTimeStamp();
void dumpStackTrace();
uchar *nativeLoadClass(UtfString className, uint32 *size);


#ifdef WITH_THREAD

//*** Isao's Multithread implementation START ***
// Thread variables - Isao F. Yamashita 07/25/2000
#define THREAD_LIST_MAX_SIZE 8

typedef struct
{
    WClass* tClass;
    WObject tObject;
    WObject syncObject;

    WClassMethod* syncMethod;

    int32   runMethodMapNum;
    int32   syncMethodMapNum;

    uint32  sleepCountSet;
    uint32  sleepCountNow;

    uchar   isSleepCountAlreadySet;

    uchar   isWaiting;
} WThread;

WThread wThreadList[THREAD_LIST_MAX_SIZE];
uint32  threadListCurrentSize;
uint32  threadProcessIndex;
uint32  threadSynchMethodIndex;

//*** This "_onThreadStart()" method is called from "start()" method.
Var ThreadStart(Var stack[]);

//*** This "_onThreadStop()" method is called from "stop()" method.
Var ThreadStop(Var stack[]);

//*** This "_onThreadSleep()" method is called from "sleep()" method.
Var ThreadSleep(Var stack[]);

//*** This "_onThreadWait()" method is called from "wait()" method.
Var ThreadWaitForSignal(Var stack[]);

Var ThreadSignalAll(Var stack[]);

//*** Isao's Multithread implementation END ***

#endif /* WITH_THREAD */

#endif /* __NMWIN32_A_H__ */
